#!/usr/bin/env python
# -*- coding: utf-8 -*-

import threading
import re
import time
import argparse

import datetime

import setproctitle
import json

from luma.core import legacy

from luma.led_matrix.device import max7219
from luma.core.interface.serial import spi, noop
from luma.core.render import canvas
from luma.core.virtual import viewport
from luma.core.legacy import text, show_message
from luma.core.legacy.font import proportional, CP437_FONT, TINY_FONT, SINCLAIR_FONT, LCD_FONT

filepath="/tmp/mqtt.log"

# create matrix device
serial = spi(port=0, device=0, gpio=noop())
device = max7219(serial, cascaded=8, block_orientation=-90, rotate=0)
#print("Created device")
device.contrast(6)

contrast = 0
contrastLast = 0
message = ""
messageLast = ""


def readTempFromFile():

	global message
	global contrast
	global temperature
        jsonfile = open(filepath, "r")
        filedata = jsonfile.read()
        jsonfile.close()
        jdata = json.loads(filedata)

        message = str(jdata["time"]) + " " + str(jdata["temperature"]) + chr(248) + "C" + str(jdata["message"])
	contrast = int(jdata["contrast"])
	valid = int(jdata["valid"])


	if valid == 0:
		message = str(jdata["time"]) + " " + str(jdata["temperature"]) + chr(248) + "C - T1" + ": " + str(jdata["sensor1"]) + chr(248) + "C T2" + ": " + str(jdata["sensor2"])  + chr(248) + "C " + str(jdata["message"])

	elif valid ==1:
		message = str(jdata["time"]) + " " + str(jdata["temperature"]) + chr(248) + "C - T1?" + ": " + str(jdata["sensor1"]) + chr(248) + "C T2?" + ": " + str(jdata["sensor2"])  + chr(248) + "C " + str(jdata["message"])

	else:
		message = str(jdata["time"]) + " " + str(jdata["temperature"]) + chr(248) + "C" + str(jdata["message"])






while True:
#	global messageLast
#	global contrastLast

	readTempFromFile();

	if contrast != contrastLast:
		device.contrast(contrast)
		contrastLast = contrast

	if contrast == 0:
		message = ""

	if len(message) < 11:
		with canvas(device) as draw:

			legacy.text(draw, (0, 0), message, fill="white", font=proportional(CP437_FONT))

	else:
		show_message(device, message, fill="white", font=proportional(CP437_FONT))

